package Data::Query::ExprBuilder;

use strictures 1;
use Data::Query::Constants qw(DQ_OPERATOR DQ_VALUE);
use Scalar::Util ();

use overload (
  (map {
    my $op = $_;
    $op => sub {
      Data::Query::ExprBuilder->new({
        expr => {
          type => DQ_OPERATOR,
          operator => { perl => $op },
          args => [
           map {
             (Scalar::Util::blessed($_)
             && $_->isa('Data::Query::ExprBuilder'))
               ? $_->{expr}
               : {
                   type => DQ_VALUE,
                   subtype => { perl => 'Scalar' },
                   value => $_
                 }
            } $_[2] ? @_[1,0] : @_[0,1]
          ]
        },
      });
    }
  } qw(==))
); 

sub new {
  bless({ %{$_[1]} }, (ref($_[0])||$_[0]));
}

1;
